<?php
defined('_JEXEC') or die('Restricted access');

class pm_bitpay extends PaymentRoot{
    
    function showPaymentForm($params, $pmconfigs){
        include(dirname(__FILE__)."/paymentform.php");
    }

	//function call in admin
	function showAdminFormParams($params){
	  $array_params = array('acc', 'transaction_end_status', 'transaction_pending_status', 'transaction_failed_status');
	  foreach ($array_params as $key){
	  	if (!isset($params[$key])) $params[$key] = '';
	  }
	  $orders = &JModel::getInstance('orders', 'JshoppingModel'); //admin model
      include(dirname(__FILE__)."/adminparamsform.php");
	}
    function get($url,$api,$trans_id,$id_get){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }

	function checkTransaction($pmconfigs, $order, $act){
        $jshopConfig = &JSFactory::getConfig();
	    $api = $pmconfigs['acc'];
        $url = 'http://bitpay.ir/payment/gateway-result-second';
	    $trans_id = $_POST['trans_id'];
        $id_get = $_POST['id_get'];
        $result = $this->get($url,$api,$trans_id,$id_get);
        if ($result == 1){
            return array(1, '');
        }else{
            $message = 'تراکنش شما لغو شده است. شناسه تراکنش : '.$order->order_id;
            $message .= '<br /> شماره تراکنش پي لاين: '.$trans_id;
            return array(0, $message);
        }
	}

	function showEndForm($pmconfigs, $order){
        
        $jshopConfig = &JSFactory::getConfig();        
	    /*$item_name = sprintf(_JSHOP_PAYMENT_PRODUCT_IN_SITE, $jshopConfig->store_name);*/
        $item_name = sprintf(_JSHOP_PAYMENT_NUMBER, $order->order_number);
        $_country = &JTable::getInstance('country', 'jshop');
        $_country->load($order->country);
        $country = $_country->country_code_2;
		$notify_url = JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=notify&js_paymentclass=pm_bitpay&no_lang=1";
        $redirectAddress = JURI::root(). "index.php?option=com_jshopping&controller=checkout&task=step7&act=return&itemnumber=".$order->order_id."&js_paymentclass=pm_bitpay";
        $cancel_return = JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=pm_bitpay";
        $api = $pmconfigs['acc'];
        ?>
        <html>
        <body>
        <head>
            <meta http-equiv="content-type" content="text/html; charset=utf-8" />            
        </head>
        <form id="paymentform" action="<?php echo JURI::base();?>components/com_jshopping/payments/pm_bitpay/request.php" name = "paymentform" method = "post">
	    <input id="TransactionAccountID" type='hidden' name='TransactionAccountID' value='<?php print $api; ?>' /><br />
	    <input id="TransactionAmount" type='hidden' name='TransactionAmount' value='<?php print round($order->order_total)*10; ?>' /><br />
	    <input id="TransactionRedirectUrl" type='hidden' name='TransactionRedirectUrl' value='<?php print $redirectAddress; ?>'/><br />
	    <input id="TransactionDesc" type='hidden' name='TransactionDesc' value='<?php print $order->order_id; ?>' /><br />  
        </form>   
		
        <?php print _JSHOP_REDIRECT_TO_PAYMENT_PAGE ?>
        <br>
        <script type="text/javascript">document.getElementById('paymentform').submit();</script>
        </body>
        </html>
        <?php
        die();
	}
    
    function getUrlParams($pmconfigs){                        
        $params = array(); 
        $params['order_id'] = JRequest::getInt("itemnumber");
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = $pmconfigs['checkdatareturn'];
    return $params;
    }
    
}
?>